searchData={"items":[{"type":"module","title":"Actors","doc":"`Actors` It's the client API for the Spawn actors.\nThrough this module we interact with the actors by creating,\ninvoking or configuring them.","ref":"Actors.html"},{"type":"function","title":"Actors.get_state/1","doc":"","ref":"Actors.html#get_state/1"},{"type":"function","title":"Actors.invoke/2","doc":"Makes a request to an actor.\n\n  * `request` - The InvocationRequest\n  * `opts` - The options to Invoke Actors\n##","ref":"Actors.html#invoke/2"},{"type":"function","title":"Actors.invoke_with_nats/2","doc":"Makes a request to an actor using Nats broker.\n\n  * `request` - The InvocationRequest\n  * `opts` - The options to Invoke Actors\n##","ref":"Actors.html#invoke_with_nats/2"},{"type":"function","title":"Actors.liveness/1","doc":"Performs a liveness check for a given actor.","ref":"Actors.html#liveness/1"},{"type":"function","title":"Parameters - Actors.liveness/1","doc":"- `actor_id` (ActorId.t()): The ID of the actor.\n- `opts` (any): Additional options.","ref":"Actors.html#liveness/1-parameters"},{"type":"function","title":"Returns - Actors.liveness/1","doc":"- `{:ok, response}`: If the response is successfully.\n- `{:error, reason}`: If an error occurs during the operation.","ref":"Actors.html#liveness/1-returns"},{"type":"function","title":"Actors.readiness/1","doc":"Performs a readiness check for a given actor.","ref":"Actors.html#readiness/1"},{"type":"function","title":"Parameters - Actors.readiness/1","doc":"- `actor_id` (ActorId.t()): The ID of the actor.\n- `opts` (any): Additional options.","ref":"Actors.html#readiness/1-parameters"},{"type":"function","title":"Returns - Actors.readiness/1","doc":"- `{:ok, response}`: If the response is successfully.\n- `{:error, reason}`: If an error occurs during the operation.","ref":"Actors.html#readiness/1-returns"},{"type":"function","title":"Actors.register/2","doc":"Registers all actors defined in HostActor.\n\n  * `registration` - The RegistrationRequest\n  * `opts` - The options to create Actors\n##","ref":"Actors.html#register/2"},{"type":"function","title":"Actors.spawn_actor/2","doc":"Spawn actors defined in HostActor.\n\n  * `registration` - The SpawnRequest\n  * `opts` - The options to create Actors\n\nspawn_actor must be used when you want to create a concrete instance of an actor\npreviously registered as unnamed.\nThat is, when an Actorid is associated with an actor of unnamed type.\nThis function only registers the metadata of the new actor, not activating it.\nThis will occur when the sprite is first invoked.\n##","ref":"Actors.html#spawn_actor/2"},{"type":"module","title":"Actors.Actor.CallerConsumer","doc":"An Elixir module representing a GenStage consumer responsible for handling\nevents initiated by `CallerProducer` and interacting with actors in the system.","ref":"Actors.Actor.CallerConsumer.html"},{"type":"function","title":"Actors.Actor.CallerConsumer.do_lookup_action/4","doc":"Performs the action of looking up or creating an actor based on the given parameters.\n\nThis function is responsible for looking up or creating an actor based on the specified actor\nfully-qualified domain name (FQDN). It incorporates distributed tracing with OpenTelemetry\nto capture relevant events and attributes during the lookup or creation process.","ref":"Actors.Actor.CallerConsumer.html#do_lookup_action/4"},{"type":"function","title":"Parameters - Actors.Actor.CallerConsumer.do_lookup_action/4","doc":"- `system_name` (String): The name of the actor system.\n- `actor_fqdn` (tuple): A tuple representing the fully-qualified domain name (FQDN) of the actor.\n- `system` (%ActorSystem{}): The actor system.\n- `action_fun` (function): The function to be invoked once the actor is looked up or created.\n  It receives the actor reference and actor reference ID as parameters.","ref":"Actors.Actor.CallerConsumer.html#do_lookup_action/4-parameters"},{"type":"function","title":"Tracing Context - Actors.Actor.CallerConsumer.do_lookup_action/4","doc":"The function sets up a span with the name \"actor-lookup\" to trace the lookup or creation\nprocess. It adds relevant attributes, such as the actor FQDN, to the tracing context.","ref":"Actors.Actor.CallerConsumer.html#do_lookup_action/4-tracing-context"},{"type":"function","title":"Retry Mechanism - Actors.Actor.CallerConsumer.do_lookup_action/4","doc":"The function incorporates a retry mechanism with backoff, randomization, and timeout\nto handle potential errors during the lookup or creation process.","ref":"Actors.Actor.CallerConsumer.html#do_lookup_action/4-retry-mechanism"},{"type":"function","title":"Returns - Actors.Actor.CallerConsumer.do_lookup_action/4","doc":"The result of the `action_fun` function or an error tuple in case of failure.","ref":"Actors.Actor.CallerConsumer.html#do_lookup_action/4-returns"},{"type":"function","title":"Error Handling - Actors.Actor.CallerConsumer.do_lookup_action/4","doc":"In case of errors during the lookup or creation process, appropriate logging and tracing events\nare added, and the error is returned as part of the result tuple.","ref":"Actors.Actor.CallerConsumer.html#do_lookup_action/4-error-handling"},{"type":"function","title":"Actors.Actor.CallerConsumer.get_state/1","doc":"Gets the state of the specified actor.\n\nThis function attempts to retrieve the state of the actor identified by the given\n`ActorId`. It uses an exponential backoff strategy for retrying in case of errors\nand logs any failures.","ref":"Actors.Actor.CallerConsumer.html#get_state/1"},{"type":"function","title":"Parameters - Actors.Actor.CallerConsumer.get_state/1","doc":"- `id` (%ActorId): The unique identifier of the actor.","ref":"Actors.Actor.CallerConsumer.html#get_state/1-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerConsumer.get_state/1","doc":"The state of the actor if successful, otherwise an error is raised.","ref":"Actors.Actor.CallerConsumer.html#get_state/1-returns"},{"type":"function","title":"Retry Strategy - Actors.Actor.CallerConsumer.get_state/1","doc":"The function utilizes an exponential backoff strategy with randomized delays and\na maximum expiry time of 30,000 milliseconds.","ref":"Actors.Actor.CallerConsumer.html#get_state/1-retry-strategy"},{"type":"function","title":"Errors - Actors.Actor.CallerConsumer.get_state/1","doc":"The function handles errors such as `:error`, `:exit`, `:noproc`, `:erpc`,\n`:noconnection`, and `:timeout`. It also rescues `ErlangError` exceptions and logs\ndetailed error messages.","ref":"Actors.Actor.CallerConsumer.html#get_state/1-errors"},{"type":"function","title":"Actors.Actor.CallerConsumer.handle_events/3","doc":"Handles incoming events from the `CallerProducer` GenStage.\n\nDispatches events to the appropriate functions for further processing.","ref":"Actors.Actor.CallerConsumer.html#handle_events/3"},{"type":"function","title":"Actors.Actor.CallerConsumer.init/1","doc":"Initializes the GenStage consumer.\n\nIt subscribes to the `CallerProducer` GenStage with specified backpressure values.","ref":"Actors.Actor.CallerConsumer.html#init/1"},{"type":"function","title":"Actors.Actor.CallerConsumer.invoke_with_span/2","doc":"Invokes an actor action with distributed tracing using OpenTelemetry.\n\nThis function performs an actor action invocation, incorporating distributed tracing\nwith OpenTelemetry. It sets up the tracing context, adds relevant attributes,\nand handles asynchronous and synchronous invocations.","ref":"Actors.Actor.CallerConsumer.html#invoke_with_span/2"},{"type":"function","title":"Parameters - Actors.Actor.CallerConsumer.invoke_with_span/2","doc":"- `request` (%InvocationRequest): The request containing information about the invocation.\n- `opts` (Keyword.t): Additional options for the invocation. Defaults to an empty keyword list.","ref":"Actors.Actor.CallerConsumer.html#invoke_with_span/2-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerConsumer.invoke_with_span/2","doc":"A tuple containing the status and the result of the invocation.\nIf the invocation is asynchronous, it returns `{:ok, :async}`.","ref":"Actors.Actor.CallerConsumer.html#invoke_with_span/2-returns"},{"type":"function","title":"Tracing Context - Actors.Actor.CallerConsumer.invoke_with_span/2","doc":"The function sets up the tracing context and adds attributes related to the invocation.\nIt uses OpenTelemetry to trace the client invoke with the kind set to `:client`.","ref":"Actors.Actor.CallerConsumer.html#invoke_with_span/2-tracing-context"},{"type":"function","title":"Retry Mechanism - Actors.Actor.CallerConsumer.invoke_with_span/2","doc":"The function incorporates a retry mechanism with backoff, randomization, and timeout\nto handle potential errors during the invocation.","ref":"Actors.Actor.CallerConsumer.html#invoke_with_span/2-retry-mechanism"},{"type":"function","title":"Error Handling - Actors.Actor.CallerConsumer.invoke_with_span/2","doc":"In case of errors during the invocation, appropriate logging and tracing events are added,\nand the error is re-raised with a stack trace.","ref":"Actors.Actor.CallerConsumer.html#invoke_with_span/2-error-handling"},{"type":"function","title":"Actors.Actor.CallerConsumer.liveness/1","doc":"Performs a liveness check for a given actor identified by `%ActorId{}`.\n\nThis function uses a retry mechanism with exponential backoff, randomization, and a 30-second expiry to handle errors and failures gracefully.\nIt attempts to check the liveness of the specified actor, logging any errors encountered during the process.","ref":"Actors.Actor.CallerConsumer.html#liveness/1"},{"type":"function","title":"Parameters - Actors.Actor.CallerConsumer.liveness/1","doc":"- `id`: An `%ActorId{}` struct that contains:\n    - `name`: The name of the actor.\n    - `system`: The name of the system the actor belongs to.","ref":"Actors.Actor.CallerConsumer.html#liveness/1-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerConsumer.liveness/1","doc":"- `{:ok, %HealthCheckReply{}}` if the liveness check is successful. The `HealthCheckReply` struct contains:\n    - `status`: A `HealthcheckStatus` struct with:\n      - `status`: A string indicating the status, e.g., \"OK\".\n      - `details`: A string providing additional details, e.g., \"I'm alive!\".\n      - `updated_at`: A `Google.Protobuf.Timestamp` indicating the last update time.\n  - An error tuple (e.g., `{:error, :noproc}`) if the liveness check fails after all retry attempts.","ref":"Actors.Actor.CallerConsumer.html#liveness/1-returns"},{"type":"function","title":"Examples - Actors.Actor.CallerConsumer.liveness/1","doc":"iex> liveness(%ActorId{name: \"actor1\", system: \"system1\"})\n    {:ok,\n      %HealthCheckReply{\n        status: %HealthcheckStatus{\n          status: \"OK\",\n          details: \"I'm still alive!\",\n          updated_at: %Google.Protobuf.Timestamp{seconds: 1717606837}\n        }\n      }}\n\n    iex> liveness(%ActorId{name: \"nonexistent_actor\", system: \"system1\"})\n    {:error, :noproc}","ref":"Actors.Actor.CallerConsumer.html#liveness/1-examples"},{"type":"function","title":"Notes - Actors.Actor.CallerConsumer.liveness/1","doc":"The retry mechanism handles the following cases: `:error`, `:exit`, `:noproc`, `:erpc`, `:noconnection`, and `:timeout`. It rescues only `ErlangError`.\n\nThe liveness check is performed by calling `ActorEntity.liveness/2` on the actor reference obtained through `do_lookup_action/4`.\n\nAny errors during the liveness check are logged with a message indicating the actor's name and the error encountered.","ref":"Actors.Actor.CallerConsumer.html#liveness/1-notes"},{"type":"function","title":"Actors.Actor.CallerConsumer.readiness/1","doc":"Performs a readiness check for a given actor identified by `%ActorId{}`.\n\nThis function uses a retry mechanism with exponential backoff, randomization, and a 30-second expiry to handle errors and failures gracefully.\nIt attempts to check the readiness of the specified actor, logging any errors encountered during the process.","ref":"Actors.Actor.CallerConsumer.html#readiness/1"},{"type":"function","title":"Parameters - Actors.Actor.CallerConsumer.readiness/1","doc":"- `id`: An `%ActorId{}` struct that contains:\n    - `name`: The name of the actor.\n    - `system`: The name of the system the actor belongs to.","ref":"Actors.Actor.CallerConsumer.html#readiness/1-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerConsumer.readiness/1","doc":"- `{:ok, %HealthCheckReply{}}` if the readiness check is successful. The `HealthCheckReply` struct contains:\n    - `status`: A `HealthcheckStatus` struct with:\n      - `status`: A string indicating the status, e.g., \"OK\".\n      - `details`: A string providing additional details, e.g., \"I'm alive!\".\n      - `updated_at`: A `Google.Protobuf.Timestamp` indicating the last update time.\n  - An error tuple (e.g., `{:error, :noproc}`) if the readiness check fails after all retry attempts.","ref":"Actors.Actor.CallerConsumer.html#readiness/1-returns"},{"type":"function","title":"Examples - Actors.Actor.CallerConsumer.readiness/1","doc":"iex> readiness(%ActorId{name: \"actor1\", system: \"system1\"})\n    {:ok,\n      %HealthCheckReply{\n        status: %HealthcheckStatus{\n          status: \"OK\",\n          details: \"I'm alive!\",\n          updated_at: %Google.Protobuf.Timestamp{seconds: 1717606730}\n        }\n      }}\n\n    iex> readiness(%ActorId{name: \"nonexistent_actor\", system: \"system1\"})\n    {:error, :noproc}","ref":"Actors.Actor.CallerConsumer.html#readiness/1-examples"},{"type":"function","title":"Notes - Actors.Actor.CallerConsumer.readiness/1","doc":"The retry mechanism handles the following cases: `:error`, `:exit`, `:noproc`, `:erpc`, `:noconnection`, and `:timeout`. It rescues only `ErlangError`.\n\nThe readiness check is performed by calling `ActorEntity.readiness/2` on the actor reference obtained through `do_lookup_action/4`.\n\nAny errors during the readiness check are logged with a message indicating the actor's name and the error encountered.","ref":"Actors.Actor.CallerConsumer.html#readiness/1-notes"},{"type":"function","title":"Actors.Actor.CallerConsumer.register/2","doc":"Registers actors in the system based on the provided registration request.\n\nHandles registration requests and ensures actors are properly registered.","ref":"Actors.Actor.CallerConsumer.html#register/2"},{"type":"function","title":"Actors.Actor.CallerConsumer.spawn_actor/2","doc":"Spawns an actor or a group of actors based on the provided `SpawnRequest`.\n\nThis function is responsible for spawning actors based on the specified `SpawnRequest`.\nIt retrieves the hosts associated with the provided actor IDs and registers the actors.\nAdditionally, it handles cases where the system is in the process of draining or stopping.","ref":"Actors.Actor.CallerConsumer.html#spawn_actor/2"},{"type":"function","title":"Parameters - Actors.Actor.CallerConsumer.spawn_actor/2","doc":"- `spawn` (%SpawnRequest): The request containing information about the actors to spawn.\n- `opts` (Keyword.t): Additional options for spawning the actors. Defaults to an empty keyword list.","ref":"Actors.Actor.CallerConsumer.html#spawn_actor/2-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerConsumer.spawn_actor/2","doc":"If successful, it returns `{:ok, %SpawnResponse{status: %RequestStatus{status: :OK, message: \"Accepted\"}}}`.\nOtherwise, an error is raised.","ref":"Actors.Actor.CallerConsumer.html#spawn_actor/2-returns"},{"type":"function","title":"Actor Spawning Process - Actors.Actor.CallerConsumer.spawn_actor/2","doc":"- Retrieves actor hosts based on actor IDs from the `ActorRegistry`.\n- Filters the hosts based on the system's graceful shutdown status.\n- Registers the selected hosts in the `ActorRegistry`.\n- Returns a success response.","ref":"Actors.Actor.CallerConsumer.html#spawn_actor/2-actor-spawning-process"},{"type":"function","title":"Errors - Actors.Actor.CallerConsumer.spawn_actor/2","doc":"- Raises an `ArgumentError` if attempting to spawn an unnamed actor that has not been registered before.","ref":"Actors.Actor.CallerConsumer.html#spawn_actor/2-errors"},{"type":"function","title":"Actors.Actor.CallerConsumer.start_link/1","doc":"Starts the consumer process and subscribes to the `CallerProducer` GenStage.","ref":"Actors.Actor.CallerConsumer.html#start_link/1"},{"type":"function","title":"Actors.Actor.CallerConsumer.try_reactivate_actor/3","doc":"Tries to reactivate an actor.\n\nReactivation is attempted by looking up the actor in the registry\nor creating a new actor if not found.","ref":"Actors.Actor.CallerConsumer.html#try_reactivate_actor/3"},{"type":"module","title":"Actors.Actor.CallerProducer","doc":"# Actors.Actor.CallerProducer\nThis module defines a GenStage producer responsible for managing actor-related\noperations such as retrieving actor state, actor registration, actor spawning, and actor invocation.","ref":"Actors.Actor.CallerProducer.html"},{"type":"module","title":"Client API - Actors.Actor.CallerProducer","doc":"The client API provides functions for interacting with actors.\nThese functions can be used to initiate operations such as getting actor state,\nregistering actors, spawning new actors, and invoking actors.","ref":"Actors.Actor.CallerProducer.html#module-client-api"},{"type":"module","title":"Functions - Actors.Actor.CallerProducer","doc":"- [`start_link/1`](#start_link-1): Starts the CallerProducer process.\n- [`get_state/2`](#get_state-2): Retrieves the state of a specified actor.\n- [`register/2`](#register-2): Registers an actor with the specified registration request.\n- [`spawn_actor/2`](#spawn_actor-2): Spawns an actor based on the specified spawn request.\n- [`invoke/2`](#invoke-2): Invokes an actor with the specified invocation request.\n- [`enqueue/1`](#enqueue-1): Enqueues an event for processing.","ref":"Actors.Actor.CallerProducer.html#module-functions"},{"type":"module","title":"Server API - Actors.Actor.CallerProducer","doc":"The server API includes functions that handle the GenStage behavior.\nThese functions manage the state and processing of events.","ref":"Actors.Actor.CallerProducer.html#module-server-api"},{"type":"module","title":"Functions - Actors.Actor.CallerProducer","doc":"- [`init/1`](#init-1): Initializes the GenStage process.\n- [`handle_demand/2`](#handle_demand-2): Handles demand requests from consumers.\n- [`handle_call/3`](#handle_call-3): Handles call requests from consumers.\n- [`handle_cast/2`](#handle_cast-2): Handles cast requests from consumers.","ref":"Actors.Actor.CallerProducer.html#module-functions"},{"type":"module","title":"Usage - Actors.Actor.CallerProducer","doc":"To interact with this module, use the client API functions provided.\nThese functions handle backpressure if enabled in the configuration.","ref":"Actors.Actor.CallerProducer.html#module-usage"},{"type":"function","title":"Actors.Actor.CallerProducer.enqueue/1","doc":"Enqueues an event for processing.","ref":"Actors.Actor.CallerProducer.html#enqueue/1"},{"type":"function","title":"Parameters - Actors.Actor.CallerProducer.enqueue/1","doc":"- `event` (any): The event to be enqueued.","ref":"Actors.Actor.CallerProducer.html#enqueue/1-parameters"},{"type":"function","title":"Actors.Actor.CallerProducer.get_state/2","doc":"Retrieves the state of a specified actor.","ref":"Actors.Actor.CallerProducer.html#get_state/2"},{"type":"function","title":"Parameters - Actors.Actor.CallerProducer.get_state/2","doc":"- `actor_id` (ActorId.t()): The ID of the actor.\n- `opts` (any): Additional options.","ref":"Actors.Actor.CallerProducer.html#get_state/2-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerProducer.get_state/2","doc":"- `{:ok, state}`: If the state is successfully retrieved.\n- `{:error, reason}`: If an error occurs during the operation.","ref":"Actors.Actor.CallerProducer.html#get_state/2-returns"},{"type":"function","title":"Actors.Actor.CallerProducer.invoke/2","doc":"Invokes an actor with the specified invocation request.","ref":"Actors.Actor.CallerProducer.html#invoke/2"},{"type":"function","title":"Parameters - Actors.Actor.CallerProducer.invoke/2","doc":"- `request` (InvocationRequest.t()): The invocation request.\n- `opts` (any): Additional options.","ref":"Actors.Actor.CallerProducer.html#invoke/2-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerProducer.invoke/2","doc":"- `{:ok, :async}`: If the invocation is asynchronous.\n- `{:ok, result}`: If the invocation is successful.\n- `{:error, reason}`: If an error occurs during the invocation.","ref":"Actors.Actor.CallerProducer.html#invoke/2-returns"},{"type":"function","title":"Actors.Actor.CallerProducer.liveness/2","doc":"Performs a liveness check for a given actor.","ref":"Actors.Actor.CallerProducer.html#liveness/2"},{"type":"function","title":"Parameters - Actors.Actor.CallerProducer.liveness/2","doc":"- `actor_id` (ActorId.t()): The ID of the actor.\n- `opts` (any): Additional options.","ref":"Actors.Actor.CallerProducer.html#liveness/2-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerProducer.liveness/2","doc":"- `{:ok, response}`: If the response is successfully.\n- `{:error, reason}`: If an error occurs during the operation.","ref":"Actors.Actor.CallerProducer.html#liveness/2-returns"},{"type":"function","title":"Actors.Actor.CallerProducer.readiness/2","doc":"Performs a readiness check for a given actor.","ref":"Actors.Actor.CallerProducer.html#readiness/2"},{"type":"function","title":"Parameters - Actors.Actor.CallerProducer.readiness/2","doc":"- `actor_id` (ActorId.t()): The ID of the actor.\n- `opts` (any): Additional options.","ref":"Actors.Actor.CallerProducer.html#readiness/2-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerProducer.readiness/2","doc":"- `{:ok, response}`: If the response is successfully.\n- `{:error, reason}`: If an error occurs during the operation.","ref":"Actors.Actor.CallerProducer.html#readiness/2-returns"},{"type":"function","title":"Actors.Actor.CallerProducer.register/2","doc":"Registers an actor with the specified registration request.","ref":"Actors.Actor.CallerProducer.html#register/2"},{"type":"function","title":"Parameters - Actors.Actor.CallerProducer.register/2","doc":"- `registration` (RegistrationRequest.t()): The registration request.\n- `opts` (any): Additional options.","ref":"Actors.Actor.CallerProducer.html#register/2-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerProducer.register/2","doc":"- `{:ok, response}`: If the actor is successfully registered.\n- `{:error, response}`: If an error occurs during the registration.","ref":"Actors.Actor.CallerProducer.html#register/2-returns"},{"type":"function","title":"Actors.Actor.CallerProducer.spawn_actor/2","doc":"Spawns an actor based on the specified spawn request.","ref":"Actors.Actor.CallerProducer.html#spawn_actor/2"},{"type":"function","title":"Parameters - Actors.Actor.CallerProducer.spawn_actor/2","doc":"- `spawn_req` (SpawnRequest.t()): The spawn request.\n- `opts` (any): Additional options.","ref":"Actors.Actor.CallerProducer.html#spawn_actor/2-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerProducer.spawn_actor/2","doc":"- `{:ok, response}`: If the actor is successfully spawned.\n- `{:error, response}`: If an error occurs during the spawning.","ref":"Actors.Actor.CallerProducer.html#spawn_actor/2-returns"},{"type":"function","title":"Actors.Actor.CallerProducer.start_link/1","doc":"Starts the CallerProducer process.","ref":"Actors.Actor.CallerProducer.html#start_link/1"},{"type":"function","title":"Parameters - Actors.Actor.CallerProducer.start_link/1","doc":"- `state` (any): Initial state for the process.","ref":"Actors.Actor.CallerProducer.html#start_link/1-parameters"},{"type":"function","title":"Returns - Actors.Actor.CallerProducer.start_link/1","doc":"- `:ignore`: If the process is already running.\n- `{:error, reason}`: If an error occurs during process initialization.\n- `{:ok, pid}`: If the process starts successfully.","ref":"Actors.Actor.CallerProducer.html#start_link/1-returns"},{"type":"module","title":"Actors.Actor.Entity","doc":"Manages the lifecycle of the Host Actor through the `Entity` module.\n\nThe `Entity` module provides a GenServer-based implementation for controlling the\nlifecycle of actors, handling various actions, and interacting with the underlying\nactor system.","ref":"Actors.Actor.Entity.html"},{"type":"module","title":"Behavior - Actors.Actor.Entity","doc":"The module implements GenServer behavior with transient restart semantics.\n\n- **Initialization:** The module initializes the actor state and handles the loading of persisted states.\n\n- **State Handling:** Manages the lifecycle of the actor, including state transitions, initialization actions, and periodic snapshots.\n\n- **Interaction:** Exposes client APIs for retrieving actor state, synchronously invoking actions, and asynchronously triggering actions.\n\n- **Terminating:** Ensures that the actor's state will be saved and performs all necessary cleanups.","ref":"Actors.Actor.Entity.html#module-behavior"},{"type":"module","title":"Client APIs - Actors.Actor.Entity","doc":"The following client APIs are available for interaction:\n\n- `start_link/1`: Starts the entity for a given actor state.\n- `get_state/2`: Retrieves the actor state directly from memory.\n- `invoke/3`: Synchronously invokes an action on an actor.\n- `invoke_async/3`: Asynchronously invokes an action on an actor.","ref":"Actors.Actor.Entity.html#module-client-apis"},{"type":"module","title":"Callbacks - Actors.Actor.Entity","doc":"- `init/1`: Initializes the actor entity.\n- `handle_continue/2`: Handles asynchronous events during the actor lifecycle.\n- `handle_call/3`: Handles synchronous calls to the actor.\n- `handle_cast/2`: Handles asynchronous casts to the actor.\n- `handle_info/2`: Handles informational messages.\n- `terminate/2`: Terminates the actor entity.","ref":"Actors.Actor.Entity.html#module-callbacks"},{"type":"module","title":"Client APIs - Actors.Actor.Entity","doc":"start_link/1: Starts the entity for a given actor state.\n\nget_state/2: Retrieves the actor state directly from memory.\n\ninvoke/3: Synchronously invokes an action on an actor.\n\ninvoke_async/3: Asynchronously invokes an action on an actor.","ref":"Actors.Actor.Entity.html#module-client-apis"},{"type":"module","title":"Usage - Actors.Actor.Entity","doc":"To use this module, start the actor by calling `start_link/1` with an initial actor state.\nInteraction with the actor is facilitated through the provided client APIs such as `get_state/2`, `invoke/3`, and `invoke_async/3`.","ref":"Actors.Actor.Entity.html#module-usage"},{"type":"module","title":"Example - Actors.Actor.Entity","doc":"```elixir\n{:ok, actor} = Actors.Actor.Entity.start_link(%EntityState{actor: %Actor{id: %ActorId{name: \"example\"}}})\nstate = Actors.Actor.Entity.get_state(actor)\n{:ok, result} = Actors.Actor.Entity.invoke(actor, %InvocationRequest{action: :some_action})\n```\n\nNote: Ensure proper configuration and integration with the distributed system for seamless actor interactions.","ref":"Actors.Actor.Entity.html#module-example"},{"type":"function","title":"Actors.Actor.Entity.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Actors.Actor.Entity.html#child_spec/1"},{"type":"function","title":"Actors.Actor.Entity.get_state/2","doc":"Retrieve the Actor state direct from memory.","ref":"Actors.Actor.Entity.html#get_state/2"},{"type":"function","title":"Actors.Actor.Entity.handle_call/3","doc":"Handles different types of incoming `call` actions for an actor process.\n\nThis function is responsible for processing actions sent to the actor. It distinguishes between invocation requests\nand other default actions. The main action handled is the `:invocation_request`, which includes logic for task-based\nactors and synchronous execution.","ref":"Actors.Actor.Entity.html#handle_call/3"},{"type":"function","title":"Parameters: - Actors.Actor.Entity.handle_call/3","doc":"- `action`: Represents the action to be handled by the actor. It can be a tuple of `{:invocation_request, invocation, opts}`\n    or other actions.\n  - `from`: The caller process that made the request, usually a tuple containing the PID and a reference.\n  - `state`: The current state of the actor, typically passed in a packed format and unpacked at the start of the function.","ref":"Actors.Actor.Entity.html#handle_call/3-parameters"},{"type":"function","title":"Action Handling: - Actors.Actor.Entity.handle_call/3","doc":"- `{:invocation_request, invocation, opts}`:\n    - If the actor is of kind `:TASK`, the function schedules the task execution remotely using `FlameScheduler.schedule_and_invoke/2`.\n    - For non-task actors, the function directly invokes the action using `Invocation.invoke/2`.\n  - Default actions are delegated to `do_handle_defaults/3`.","ref":"Actors.Actor.Entity.html#handle_call/3-action-handling"},{"type":"function","title":"Return Value: - Actors.Actor.Entity.handle_call/3","doc":"The function returns a packed response, which is either the result of an invocation or the default action handling.\nThe response is further processed by `parse_packed_response/1`.","ref":"Actors.Actor.Entity.html#handle_call/3-return-value"},{"type":"function","title":"Workflow: - Actors.Actor.Entity.handle_call/3","doc":"1. The actor's state is unpacked via `EntityState.unpack/1`.\n2. Based on the `action`:\n    - For `{:invocation_request, invocation, opts}`, the function checks if the actor is of kind `:TASK`:\n      - If true, the invocation is handled remotely with the remote task scheduler (`FlameScheduler`), ensuring proper remote invocation while maintaining local state consistency.\n      - Otherwise, the action is invoked locally.\n    - For other actions, `do_handle_defaults/3` is called to manage additional behaviors.\n3. The final response is returned as a packed structure after being processed by `parse_packed_response/1`.","ref":"Actors.Actor.Entity.html#handle_call/3-workflow"},{"type":"function","title":"See Also: - Actors.Actor.Entity.handle_call/3","doc":"- `handle_invocation_request/4`\n  - `schedule_task_invocation/3`\n  - `FlameScheduler.schedule_and_invoke/2`\n  - `Invocation.invoke/2`","ref":"Actors.Actor.Entity.html#handle_call/3-see-also"},{"type":"function","title":"Actors.Actor.Entity.invoke/3","doc":"Synchronously invokes an Action on an Actor.","ref":"Actors.Actor.Entity.html#invoke/3"},{"type":"function","title":"Actors.Actor.Entity.invoke_async/3","doc":"Asynchronously invokes an Action on an Actor.","ref":"Actors.Actor.Entity.html#invoke_async/3"},{"type":"function","title":"Actors.Actor.Entity.liveness/2","doc":"Retrieve the health check liveness status.","ref":"Actors.Actor.Entity.html#liveness/2"},{"type":"function","title":"Actors.Actor.Entity.readiness/2","doc":"Retrieve the health check readiness status.","ref":"Actors.Actor.Entity.html#readiness/2"},{"type":"function","title":"Actors.Actor.Entity.replay/2","doc":"When the Actor is a Projection the messages sent to the projection can be reprocessed.\nSee this for more information about this programming model.","ref":"Actors.Actor.Entity.html#replay/2"},{"type":"function","title":"Actors.Actor.Entity.start_link/1","doc":"Starts the entity for a given actor state.","ref":"Actors.Actor.Entity.html#start_link/1"},{"type":"module","title":"Actors.Actor.Entity.EntityState","doc":"`EntityState` Represents the internal state of an Actor.","ref":"Actors.Actor.Entity.EntityState.html"},{"type":"function","title":"Actors.Actor.Entity.EntityState.pack/1","doc":"","ref":"Actors.Actor.Entity.EntityState.html#pack/1"},{"type":"type","title":"Actors.Actor.Entity.EntityState.t/0","doc":"","ref":"Actors.Actor.Entity.EntityState.html#t:t/0"},{"type":"function","title":"Actors.Actor.Entity.EntityState.unpack/1","doc":"","ref":"Actors.Actor.Entity.EntityState.html#unpack/1"},{"type":"module","title":"Actors.Actor.Entity.Invocation","doc":"Handles Invocation functions for Actor Entity\nAll the public functions here assumes they are executing inside a GenServer","ref":"Actors.Actor.Entity.Invocation.html"},{"type":"function","title":"Actors.Actor.Entity.Invocation.do_broadcast/3","doc":"","ref":"Actors.Actor.Entity.Invocation.html#do_broadcast/3"},{"type":"function","title":"Actors.Actor.Entity.Invocation.do_side_effects/3","doc":"","ref":"Actors.Actor.Entity.Invocation.html#do_side_effects/3"},{"type":"function","title":"Actors.Actor.Entity.Invocation.handle_response/4","doc":"","ref":"Actors.Actor.Entity.Invocation.html#handle_response/4"},{"type":"function","title":"Actors.Actor.Entity.Invocation.handle_timers/3","doc":"","ref":"Actors.Actor.Entity.Invocation.html#handle_timers/3"},{"type":"function","title":"Actors.Actor.Entity.Invocation.invoke/2","doc":"Handles the invocation of actions on an Actor Entity.","ref":"Actors.Actor.Entity.Invocation.html#invoke/2"},{"type":"function","title":"Parameters - Actors.Actor.Entity.Invocation.invoke/2","doc":"- `invocation` (%InvocationRequest{}): A struct representing the invocation request, including details about the actor, action, and payload.\n- `opts` (Keyword.t): Additional options for the invocation.","ref":"Actors.Actor.Entity.Invocation.html#invoke/2-parameters"},{"type":"function","title":"Returns - Actors.Actor.Entity.Invocation.invoke/2","doc":"- `{:reply, result, new_state}`: If the invocation is successful, returns a tuple containing the reply result, and the updated entity state.\n- `{:noreply, new_state}`: If the invocation is successful, but there is no specific reply result.\n- `{:noreply, new_state, opts}`: If the invocation is successful and includes additional options.\n- `{:error, reason, new_state}`: If there is an error during the invocation, returns a tuple with the reason for the error and the updated entity state.","ref":"Actors.Actor.Entity.Invocation.html#invoke/2-returns"},{"type":"function","title":"Behavior - Actors.Actor.Entity.Invocation.invoke/2","doc":"The `invoke/2` function is responsible for handling the invocation of actions on an Actor Entity.\nIt verifies authorization, finds the appropriate action to execute, and delegates the invocation to the corresponding interface.\n\nThe function performs the following steps:\n\n1. **Authorization Check:** Checks if the invocation is authorized based on the actor's actions and timers.\n\n2. **Span Context Handling:** Uses OpenTelemetry for tracing and creates a new span for the invocation.\n\n3. **Find Request by Action:** Determines the appropriate interface and builds the request based on the action.\n\n4. **Invocation Host Handling:** Delegates the invocation to the selected interface's `invoke_host/3` function.\n\n5. **Handle Response:** Processes the response from the invocation, handles side effects, and updates the entity state.\n\n6. **Checkpoint:** Optionally performs a checkpoint operation to record the state revision.","ref":"Actors.Actor.Entity.Invocation.html#invoke/2-behavior"},{"type":"function","title":"Example - Actors.Actor.Entity.Invocation.invoke/2","doc":"```elixir\ninvocation = %InvocationRequest{\n  actor: %Actor{id: %ActorId{name: \"example_actor\"}},\n  action_name: \"perform_action\",\n  payload: {:data, %{}},\n  caller: %ActorId{name: \"caller_actor\"}\n}\n\nopts = [span_ctx: OpenTelemetry.Ctx.new()]\n\ncase Actors.Actor.Entity.Invocation.invoke({invocation, opts}, entity_state) do\n  {:reply, result, new_state} ->\n    IO.puts(\"Invocation successful! Result: {result}\")\n  {:noreply, new_state} ->\n    IO.puts(\"Invocation successful! No specific reply.\")\n  {:error, reason, new_state} ->\n    IO.puts(\"Invocation failed. Reason: {reason}\")\nend\n```","ref":"Actors.Actor.Entity.Invocation.html#invoke/2-example"},{"type":"function","title":"Actors.Actor.Entity.Invocation.invoke_init/1","doc":"Handles the initialization invocation for an Actor Entity.","ref":"Actors.Actor.Entity.Invocation.html#invoke_init/1"},{"type":"function","title":"Parameters - Actors.Actor.Entity.Invocation.invoke_init/1","doc":"- `state` (%EntityState{}): The current state of the Actor Entity.","ref":"Actors.Actor.Entity.Invocation.html#invoke_init/1-parameters"},{"type":"function","title":"Returns - Actors.Actor.Entity.Invocation.invoke_init/1","doc":"- `{:noreply, new_state}`: If the initialization is successful.\n- `{:noreply, new_state}`: If the actor has not registered any actions, indicating a warning.\n- `{:error, reason, new_state}`: If there is an error during the initialization, returns a tuple with the reason for the error and the updated entity state.","ref":"Actors.Actor.Entity.Invocation.html#invoke_init/1-returns"},{"type":"function","title":"Behavior - Actors.Actor.Entity.Invocation.invoke_init/1","doc":"The `invoke_init/1` function is responsible for handling the initialization invocation of an Actor Entity. It checks if the actor has registered any actions and performs the following steps:\n\n1. **Action Registration Check:** Checks if the actor has registered any actions. If not, it logs a warning and returns `{:noreply, new_state}`.\n\n2. **Init Action Selection:** Filters the registered actions to find the initialization action (`init` or similar) and selects the first matching action.\n\n3. **Interface Invocation:** Invokes the selected initialization action using the appropriate interface.\n\n4. **Handling Initialization Result:** Processes the result of the initialization, updating the entity state accordingly.","ref":"Actors.Actor.Entity.Invocation.html#invoke_init/1-behavior"},{"type":"function","title":"Example - Actors.Actor.Entity.Invocation.invoke_init/1","doc":"```elixir\nstate = %EntityState{\n  system: %ActorSystem{name: \"example_system\"},\n  actor: %Actor{\n    id: %ActorId{name: \"example_actor\"},\n    actions: [\"init\", \"perform_action\"],\n    state: %{}\n  },\n  opts: %{}\n}\n\ncase Actors.Actor.Entity.Invocation.invoke_init(state) do\n  {:noreply, new_state} ->\n    IO.puts(\"Initialization successful!\")\n  {:error, reason, new_state} ->\n    IO.puts(\"Initialization failed. Reason: {reason}\")\nend\n```","ref":"Actors.Actor.Entity.Invocation.html#invoke_init/1-example"},{"type":"function","title":"Actors.Actor.Entity.Invocation.process_projection_events/2","doc":"","ref":"Actors.Actor.Entity.Invocation.html#process_projection_events/2"},{"type":"function","title":"Actors.Actor.Entity.Invocation.replay/2","doc":"","ref":"Actors.Actor.Entity.Invocation.html#replay/2"},{"type":"function","title":"Actors.Actor.Entity.Invocation.replay/3","doc":"","ref":"Actors.Actor.Entity.Invocation.html#replay/3"},{"type":"module","title":"Actors.Actor.Entity.Lifecycle","doc":"Handles lifecycle functions for Actor Entity\nAll the public functions here assumes they are executing inside a GenServer","ref":"Actors.Actor.Entity.Lifecycle.html"},{"type":"function","title":"Actors.Actor.Entity.Lifecycle.checkpoint/2","doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#checkpoint/2"},{"type":"function","title":"Actors.Actor.Entity.Lifecycle.deactivate/1","doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#deactivate/1"},{"type":"function","title":"Actors.Actor.Entity.Lifecycle.get_state/2","doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#get_state/2"},{"type":"function","title":"Actors.Actor.Entity.Lifecycle.init/1","doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#init/1"},{"type":"function","title":"Actors.Actor.Entity.Lifecycle.load_state/1","doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#load_state/1"},{"type":"function","title":"Actors.Actor.Entity.Lifecycle.snapshot/1","doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#snapshot/1"},{"type":"function","title":"Actors.Actor.Entity.Lifecycle.terminate/2","doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#terminate/2"},{"type":"module","title":"Actors.Actor.Entity.Lifecycle.StreamInitiator","doc":"Handles lifecycle functions for Actor Entity that interacts with Event Source mechanisms","ref":"Actors.Actor.Entity.Lifecycle.StreamInitiator.html"},{"type":"function","title":"Actors.Actor.Entity.Lifecycle.StreamInitiator.init_projection_stream/1","doc":"","ref":"Actors.Actor.Entity.Lifecycle.StreamInitiator.html#init_projection_stream/1"},{"type":"function","title":"Actors.Actor.Entity.Lifecycle.StreamInitiator.init_sourceable_stream/1","doc":"","ref":"Actors.Actor.Entity.Lifecycle.StreamInitiator.html#init_sourceable_stream/1"},{"type":"function","title":"Actors.Actor.Entity.Lifecycle.StreamInitiator.replay/3","doc":"","ref":"Actors.Actor.Entity.Lifecycle.StreamInitiator.html#replay/3"},{"type":"function","title":"Actors.Actor.Entity.Lifecycle.StreamInitiator.stream_name/2","doc":"","ref":"Actors.Actor.Entity.Lifecycle.StreamInitiator.html#stream_name/2"},{"type":"module","title":"Actors.Actor.Entity.Supervisor","doc":"`Entity.Supervisor` is the Supervisor of all Host Actors in the system.\nThis in turn is Partitioned using a PartitionSupervisor.\nWe use a hash function based on each Actor's child_spec to partition the actors\nso that the entire Supervisor is not overloaded and\nlessening the possibility of cascading failures.","ref":"Actors.Actor.Entity.Supervisor.html"},{"type":"function","title":"Actors.Actor.Entity.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Actors.Actor.Entity.Supervisor.html#child_spec/1"},{"type":"function","title":"Actors.Actor.Entity.Supervisor.lookup_or_create_actor/3","doc":"Adds a Actor to the dynamic supervisor.","ref":"Actors.Actor.Entity.Supervisor.html#lookup_or_create_actor/3"},{"type":"function","title":"Actors.Actor.Entity.Supervisor.start_link/1","doc":"","ref":"Actors.Actor.Entity.Supervisor.html#start_link/1"},{"type":"behaviour","title":"Actors.Actor.Interface","doc":"`Invoker` is responsible for making calls to the Host Function","ref":"Actors.Actor.Interface.html"},{"type":"type","title":"Actors.Actor.Interface.default_methods/0","doc":"","ref":"Actors.Actor.Interface.html#t:default_methods/0"},{"type":"callback","title":"Actors.Actor.Interface.invoke_host/3","doc":"","ref":"Actors.Actor.Interface.html#c:invoke_host/3"},{"type":"type","title":"Actors.Actor.Interface.payload/0","doc":"","ref":"Actors.Actor.Interface.html#t:payload/0"},{"type":"type","title":"Actors.Actor.Interface.state/0","doc":"","ref":"Actors.Actor.Interface.html#t:state/0"},{"type":"module","title":"Actors.Actor.Interface.Http","doc":"`Http` is responsible for the communication between the Proxy and the Host application\nwhen using the HTTP protocol.","ref":"Actors.Actor.Interface.Http.html"},{"type":"module","title":"Actors.Actor.InvocationScheduler","doc":"`InvocationScheduler` is a global process for the cluster that controls\nall Actions of type Schedule.\nThis process is global to allow that even after restarts of a process or restart\nof an application we will still be able to perform invocations to actors,\nwithout the need for persistent storage such as a database.","ref":"Actors.Actor.InvocationScheduler.html"},{"type":"function","title":"Actors.Actor.InvocationScheduler.child_spec/0","doc":"","ref":"Actors.Actor.InvocationScheduler.html#child_spec/0"},{"type":"function","title":"Actors.Actor.InvocationScheduler.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Actors.Actor.InvocationScheduler.html#child_spec/1"},{"type":"function","title":"Actors.Actor.InvocationScheduler.next_hibernate_delay/0","doc":"","ref":"Actors.Actor.InvocationScheduler.html#next_hibernate_delay/0"},{"type":"function","title":"Actors.Actor.InvocationScheduler.schedule_fixed_invocations/1","doc":"","ref":"Actors.Actor.InvocationScheduler.html#schedule_fixed_invocations/1"},{"type":"function","title":"Actors.Actor.InvocationScheduler.schedule_invoke/2","doc":"","ref":"Actors.Actor.InvocationScheduler.html#schedule_invoke/2"},{"type":"function","title":"Actors.Actor.InvocationScheduler.start_link/0","doc":"","ref":"Actors.Actor.InvocationScheduler.html#start_link/0"},{"type":"module","title":"Actors.Actor.Pool","doc":"This module provides functions for creating actor host pools for pooled actors.","ref":"Actors.Actor.Pool.html"},{"type":"function","title":"Actors.Actor.Pool.create_actor_host_pool/2","doc":"Creates an actor host pool for a given pooled actor.","ref":"Actors.Actor.Pool.html#create_actor_host_pool/2"},{"type":"function","title":"Parameters - Actors.Actor.Pool.create_actor_host_pool/2","doc":"- `actor`: The actor for which the host pool should be created.\n- `opts`: Additional options for the host pool.","ref":"Actors.Actor.Pool.html#create_actor_host_pool/2-parameters"},{"type":"function","title":"Returns - Actors.Actor.Pool.create_actor_host_pool/2","doc":"Returns a list of `HostActor` structs representing the hosts in the pool.","ref":"Actors.Actor.Pool.html#create_actor_host_pool/2-returns"},{"type":"module","title":"Actors.Actor.Pubsub","doc":"","ref":"Actors.Actor.Pubsub.html"},{"type":"function","title":"Actors.Actor.Pubsub.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Actors.Actor.Pubsub.html#child_spec/1"},{"type":"function","title":"Actors.Actor.Pubsub.publish/3","doc":"","ref":"Actors.Actor.Pubsub.html#publish/3"},{"type":"function","title":"Actors.Actor.Pubsub.start_link/1","doc":"","ref":"Actors.Actor.Pubsub.html#start_link/1"},{"type":"function","title":"Actors.Actor.Pubsub.subscribe/4","doc":"Subscribes a specific actor to a topic","ref":"Actors.Actor.Pubsub.html#subscribe/4"},{"type":"module","title":"Actors.Actor.PubsubDispatcher","doc":"Custom PubsubDispatcher dispatcher to send subscriber metadata with the message.","ref":"Actors.Actor.PubsubDispatcher.html"},{"type":"module","title":"Actors.Actor.StateManager","doc":"`StateManager` Implements behavior that allows an Actor's state to be saved\nto persistent storage using database drivers.","ref":"Actors.Actor.StateManager.html"},{"type":"function","title":"Actors.Actor.StateManager.is_new?/2","doc":"","ref":"Actors.Actor.StateManager.html#is_new?/2"},{"type":"function","title":"Actors.Actor.StateManager.load/1","doc":"","ref":"Actors.Actor.StateManager.html#load/1"},{"type":"function","title":"Actors.Actor.StateManager.load/2","doc":"","ref":"Actors.Actor.StateManager.html#load/2"},{"type":"function","title":"Actors.Actor.StateManager.projection_create_or_update_table/2","doc":"","ref":"Actors.Actor.StateManager.html#projection_create_or_update_table/2"},{"type":"function","title":"Actors.Actor.StateManager.projection_query/4","doc":"","ref":"Actors.Actor.StateManager.html#projection_query/4"},{"type":"function","title":"Actors.Actor.StateManager.projection_upsert/3","doc":"","ref":"Actors.Actor.StateManager.html#projection_upsert/3"},{"type":"function","title":"Actors.Actor.StateManager.save/3","doc":"","ref":"Actors.Actor.StateManager.html#save/3"},{"type":"function","title":"Actors.Actor.StateManager.save_async/3","doc":"","ref":"Actors.Actor.StateManager.html#save_async/3"},{"type":"behaviour","title":"Actors.Actor.StateManager.Behaviour","doc":"`StateManager.Behaviour` Defines behavior that allows an Actor's state\nto be saved to persistent storage using database drivers.","ref":"Actors.Actor.StateManager.Behaviour.html"},{"type":"type","title":"Actors.Actor.StateManager.Behaviour.data/0","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#t:data/0"},{"type":"callback","title":"Actors.Actor.StateManager.Behaviour.is_new?/2","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:is_new?/2"},{"type":"callback","title":"Actors.Actor.StateManager.Behaviour.load/1","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:load/1"},{"type":"callback","title":"Actors.Actor.StateManager.Behaviour.load/2","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:load/2"},{"type":"type","title":"Actors.Actor.StateManager.Behaviour.opts/0","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#t:opts/0"},{"type":"type","title":"Actors.Actor.StateManager.Behaviour.params/0","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#t:params/0"},{"type":"callback","title":"Actors.Actor.StateManager.Behaviour.projection_create_or_update_table/2","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:projection_create_or_update_table/2"},{"type":"callback","title":"Actors.Actor.StateManager.Behaviour.projection_query/4","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:projection_query/4"},{"type":"type","title":"Actors.Actor.StateManager.Behaviour.projection_type/0","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#t:projection_type/0"},{"type":"callback","title":"Actors.Actor.StateManager.Behaviour.projection_upsert/3","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:projection_upsert/3"},{"type":"type","title":"Actors.Actor.StateManager.Behaviour.query/0","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#t:query/0"},{"type":"callback","title":"Actors.Actor.StateManager.Behaviour.save/3","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:save/3"},{"type":"callback","title":"Actors.Actor.StateManager.Behaviour.save_async/3","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:save_async/3"},{"type":"type","title":"Actors.Actor.StateManager.Behaviour.table_name/0","doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#t:table_name/0"},{"type":"behaviour","title":"Actors.Config","doc":"`Config` defines methods that allow recovery of system settings","ref":"Actors.Config.html"},{"type":"callback","title":"Actors.Config.get/1","doc":"","ref":"Actors.Config.html#c:get/1"},{"type":"callback","title":"Actors.Config.load/0","doc":"","ref":"Actors.Config.html#c:load/0"},{"type":"module","title":"Actors.Config.PersistentTermConfig","doc":"`Config.PersistentTermConfig` Implements the `Config` behavior\nto allow the retrieval of system variables\nthat will be included in the system configuration.","ref":"Actors.Config.PersistentTermConfig.html"},{"type":"module","title":"Actors.K8s.K8sConn","doc":"Initializes the %K8s.Conn{} struct depending on the mix environment.","ref":"Actors.K8s.K8sConn.html"},{"type":"function","title":"Actors.K8s.K8sConn.get/1","doc":"","ref":"Actors.K8s.K8sConn.html#get/1"},{"type":"function","title":"Actors.K8s.K8sConn.get!/1","doc":"","ref":"Actors.K8s.K8sConn.html#get!/1"},{"type":"module","title":"Actors.Node.Client","doc":"`Node.Client` Uses the HTTP interface to communicate with the application\nthat owns the ActorHosts.","ref":"Actors.Node.Client.html"},{"type":"function","title":"Actors.Node.Client.invoke_host_actor/2","doc":"","ref":"Actors.Node.Client.html#invoke_host_actor/2"},{"type":"module","title":"Actors.Registry.ActorRegistry","doc":"The `ActorRegistry` module provides a registry for actor entities.\n\nIt allows for registering and looking up actors and also provides\nmethods for adding and removing invocation requests for actors.","ref":"Actors.Registry.ActorRegistry.html"},{"type":"function","title":"Actors.Registry.ActorRegistry.get_hosts_by_actor/2","doc":"Retrieves a list of hosts associated with a given actor.\nParameters\n\nactor_id (%ActorId{}): The ID of the actor.\nopts (Keyword, optional): Options for the function.\n    :parent (boolean): If true, filter hosts by parent; otherwise, filter by name.\n\nReturns\n\n{:ok, hosts}: A tuple with :ok and a list of hosts.\n{:not_found, []}: If no hosts are found.\n\nExamples\n\n```elixir\nactor_id = %ActorId{parent: \"parent\", name: \"name\"}\nopts = [parent: true]\n{:ok, hosts} = Actors.Registry.ActorRegistry.get_hosts_by_actor(actor_id, opts)\n\n```","ref":"Actors.Registry.ActorRegistry.html#get_hosts_by_actor/2"},{"type":"function","title":"Actors.Registry.ActorRegistry.lookup/2","doc":"Fetch current entities of the service.\nReturns `HostActor` with Host and specific actor.","ref":"Actors.Registry.ActorRegistry.html#lookup/2"},{"type":"function","title":"Actors.Registry.ActorRegistry.register/1","doc":"Register `member` entities to the ActorRegistry.\nReturns `Cluster` with all Host members.","ref":"Actors.Registry.ActorRegistry.html#register/1"},{"type":"function","title":"Examples - Actors.Registry.ActorRegistry.register/1","doc":"iex> hosts = [%HostActor{node: Node.self(), actor: actor, opts: []}}]\n    iex> ActorRegistry.register(hosts)\n    :ok","ref":"Actors.Registry.ActorRegistry.html#register/1-examples"},{"type":"module","title":"Actors.Registry.HostActor","doc":"`HostActor` Defines the type of Actor that will be registered in `ActorRegistry`.","ref":"Actors.Registry.HostActor.html"},{"type":"type","title":"Actors.Registry.HostActor.t/0","doc":"","ref":"Actors.Registry.HostActor.html#t:t/0"},{"type":"module","title":"Actors.Registry.LoadBalance.Strategies.Random","doc":"`Random` implements the `Actors.Registry.LoadBalance.Strategy` behavior\nby searching the actors randomly, that is,\nif you have registered the same actor in N nodes and try to invoke it,\nthe Registry can, if configured,\nuse the random strategy to locate one of them in any of the nodes in a random way,\nas the name suggests.","ref":"Actors.Registry.LoadBalance.Strategies.Random.html"},{"type":"module","title":"Actors.Registry.LoadBalance.Strategies.RoundRobin","doc":"`RoundRobin` implements the `Actors.Registry.LoadBalance.Strategy` behavior\nby searching the actors using a RoundRobin strategy,\nthat is, it will try to distribute the load equally among the nodes.","ref":"Actors.Registry.LoadBalance.Strategies.RoundRobin.html"},{"type":"behaviour","title":"Actors.Registry.LoadBalance.Strategy","doc":"`LoadBalance.Strategy` Define an interface to allow the search of actors\nin the Distributed Registry.","ref":"Actors.Registry.LoadBalance.Strategy.html"},{"type":"type","title":"Actors.Registry.LoadBalance.Strategy.hosts/0","doc":"","ref":"Actors.Registry.LoadBalance.Strategy.html#t:hosts/0"},{"type":"callback","title":"Actors.Registry.LoadBalance.Strategy.next_host/2","doc":"","ref":"Actors.Registry.LoadBalance.Strategy.html#c:next_host/2"},{"type":"type","title":"Actors.Registry.LoadBalance.Strategy.opts/0","doc":"","ref":"Actors.Registry.LoadBalance.Strategy.html#t:opts/0"},{"type":"module","title":"Actors.Registry.LoadBalancer","doc":"`LoadBalance` to call hosts","ref":"Actors.Registry.LoadBalancer.html"},{"type":"function","title":"Actors.Registry.LoadBalancer.next_host/1","doc":"","ref":"Actors.Registry.LoadBalancer.html#next_host/1"},{"type":"behaviour","title":"Actors.Security.Acl","doc":"`Acl` is a acces control list helper module","ref":"Actors.Security.Acl.html"},{"type":"type","title":"Actors.Security.Acl.base_policies_path/0","doc":"","ref":"Actors.Security.Acl.html#t:base_policies_path/0"},{"type":"callback","title":"Actors.Security.Acl.get_policies!/0","doc":"","ref":"Actors.Security.Acl.html#c:get_policies!/0"},{"type":"type","title":"Actors.Security.Acl.invocation/0","doc":"","ref":"Actors.Security.Acl.html#t:invocation/0"},{"type":"callback","title":"Actors.Security.Acl.is_authorized?/2","doc":"","ref":"Actors.Security.Acl.html#c:is_authorized?/2"},{"type":"callback","title":"Actors.Security.Acl.load_acl_policies/1","doc":"","ref":"Actors.Security.Acl.html#c:load_acl_policies/1"},{"type":"type","title":"Actors.Security.Acl.policies/0","doc":"","ref":"Actors.Security.Acl.html#t:policies/0"},{"type":"module","title":"Actors.Security.Acl.DefaultAclManager","doc":"","ref":"Actors.Security.Acl.DefaultAclManager.html"},{"type":"function","title":"Actors.Security.Acl.DefaultAclManager.load_acl_policies/1","doc":"`DefaultAclManager`","ref":"Actors.Security.Acl.DefaultAclManager.html#load_acl_policies/1"},{"type":"module","title":"Actors.Security.Acl.Policy","doc":"","ref":"Actors.Security.Acl.Policy.html"},{"type":"type","title":"Actors.Security.Acl.Policy.t/0","doc":"","ref":"Actors.Security.Acl.Policy.html#t:t/0"},{"type":"module","title":"Actors.Security.Acl.Rules.AclEvaluator","doc":"`AclEvaluator`is responsible for evaluating whether a request can be accepted\nor not based on the informed Access Control List policy.","ref":"Actors.Security.Acl.Rules.AclEvaluator.html"},{"type":"function","title":"Actors.Security.Acl.Rules.AclEvaluator.eval/3","doc":"Applies a policy on a request by evaluating whether the request should pass or not.","ref":"Actors.Security.Acl.Rules.AclEvaluator.html#eval/3"},{"type":"function","title":"Example - Actors.Security.Acl.Rules.AclEvaluator.eval/3","doc":"iex> Actors.Security.Acl.Rules.AclEvaluator.eval(\n    ...> %Actors.Security.Acl.Policy{\n    ...>   name: \"the-police\",\n    ...>   type: :allow,\n    ...>   actors: [\"*\"],\n    ...>   actions: [\"get\"],\n    ...>   actor_systems: [\"*\"]\n    ...> },\n    ...> %Spawn.InvocationRequest{\n    ...>    actor: %Spawn.Actors.Actor{id: %Spawn.Actors.ActorId{name: \"joe\"}},\n    ...>    action_name: \"get\",\n    ...>    caller: %Spawn.Actors.ActorId{name: \"robert\", system: \"actor-system\"}\n    ...> }\n    ...> )\n    true","ref":"Actors.Security.Acl.Rules.AclEvaluator.html#eval/3-example"},{"type":"module","title":"Actors.Security.Tls.Initializer","doc":"This module must be used by initializing the container via initContainers\n\n```\ninitContainers:\n  - args:\n      - eval\n      - Kompost.Webhooks.bootstrap_tls(:prod, \"tls-certs\")\n    image: ghcr.io/eigr/spawn-proxy:2.0.0-RC9\n    name: init-certificates\nserviceAccountName: kompost\nvolumes:\n  - name: certs\n    secret:\n      optional: true\n      secretName: tls-certs\n```","ref":"Actors.Security.Tls.Initializer.html"},{"type":"function","title":"Actors.Security.Tls.Initializer.bootstrap_tls/5","doc":"","ref":"Actors.Security.Tls.Initializer.html#bootstrap_tls/5"},{"type":"behaviour","title":"Actors.SplitBrainDetector","doc":"","ref":"Actors.SplitBrainDetector.html"},{"type":"type","title":"Actors.SplitBrainDetector.actor_id/0","doc":"","ref":"Actors.SplitBrainDetector.html#t:actor_id/0"},{"type":"callback","title":"Actors.SplitBrainDetector.check_network_partition/3","doc":"","ref":"Actors.SplitBrainDetector.html#c:check_network_partition/3"},{"type":"callback","title":"Actors.SplitBrainDetector.check_network_partition!/3","doc":"","ref":"Actors.SplitBrainDetector.html#c:check_network_partition!/3"},{"type":"type","title":"Actors.SplitBrainDetector.node_id/0","doc":"","ref":"Actors.SplitBrainDetector.html#t:node_id/0"},{"type":"type","title":"Actors.SplitBrainDetector.status/0","doc":"","ref":"Actors.SplitBrainDetector.html#t:status/0"},{"type":"module","title":"Sidecar","doc":"Documentation for `Sidecar`.","ref":"Sidecar.html"},{"type":"module","title":"Sidecar.GRPC.CodeGenerator","doc":"Module for generating gRPC code from Protobuf files.\n\nThis module provides functionality to compile Protobuf files and generate gRPC-related code.\nIt supports both gRPC and HTTP transcoding code generation.","ref":"Sidecar.GRPC.CodeGenerator.html"},{"type":"module","title":"Usage - Sidecar.GRPC.CodeGenerator","doc":"1. Call `compile_protos/1` to generate gRPC code from Protobuf files.\n2. Ensure that Protobuf files are placed in the specified directory (`priv/protos` by default).","ref":"Sidecar.GRPC.CodeGenerator.html#module-usage"},{"type":"function","title":"Sidecar.GRPC.CodeGenerator.after_compile_hook/0","doc":"","ref":"Sidecar.GRPC.CodeGenerator.html#after_compile_hook/0"},{"type":"function","title":"Sidecar.GRPC.CodeGenerator.compile_modules/1","doc":"Compiles an Elixir module generated from Protobuf files and returns the compiled code.","ref":"Sidecar.GRPC.CodeGenerator.html#compile_modules/1"},{"type":"function","title":"Parameters: - Sidecar.GRPC.CodeGenerator.compile_modules/1","doc":"- `module` - The String of Elixir module code generated from Protobuf files.","ref":"Sidecar.GRPC.CodeGenerator.html#compile_modules/1-parameters"},{"type":"function","title":"Returns: - Sidecar.GRPC.CodeGenerator.compile_modules/1","doc":"The compiled Elixir code.","ref":"Sidecar.GRPC.CodeGenerator.html#compile_modules/1-returns"},{"type":"function","title":"Example: - Sidecar.GRPC.CodeGenerator.compile_modules/1","doc":"```elixir\nmodule_code = Sidecar.Grpc.CodeGenerator.compile_modules(generated_code)\n\nRaises:\n\nRaises an error if there are issues during the compilation process.","ref":"Sidecar.GRPC.CodeGenerator.html#compile_modules/1-example"},{"type":"function","title":"Sidecar.GRPC.CodeGenerator.compile_protos/1","doc":"Compiles Protobuf files and generates gRPC-related code.","ref":"Sidecar.GRPC.CodeGenerator.html#compile_protos/1"},{"type":"function","title":"Options: - Sidecar.GRPC.CodeGenerator.compile_protos/1","doc":"- `:protos_path` - Include path of protobufs to generate (default: \"priv/protos\").\n  - `:output_path` - Output path for generated code (default: \"priv/protos/modules\").\n  - `:http_transcoding_enabled` - Enable HTTP transcoding (default: true).","ref":"Sidecar.GRPC.CodeGenerator.html#compile_protos/1-options"},{"type":"function","title":"Example: - Sidecar.GRPC.CodeGenerator.compile_protos/1","doc":"```elixir\n  Sidecar.Grpc.CodeGenerator.compile_protos(output_path: \"custom_output\", http_transcoding_enabled: false)","ref":"Sidecar.GRPC.CodeGenerator.html#compile_protos/1-example"},{"type":"function","title":"Sidecar.GRPC.CodeGenerator.load_modules/1","doc":"Loads Elixir modules from the specified directory with a '.pb.ex' file extension.","ref":"Sidecar.GRPC.CodeGenerator.html#load_modules/1"},{"type":"function","title":"Parameters - Sidecar.GRPC.CodeGenerator.load_modules/1","doc":"- `opts` (KeywordList): Options for loading modules.\n  - `:output_path` (String): Path to the directory containing the modules. Default is \"/home/dev/workspace/spawn/priv/protos/modules\".","ref":"Sidecar.GRPC.CodeGenerator.html#load_modules/1-parameters"},{"type":"function","title":"Returns - Sidecar.GRPC.CodeGenerator.load_modules/1","doc":"A list of strings, where each string represents the content of an Elixir module file.","ref":"Sidecar.GRPC.CodeGenerator.html#load_modules/1-returns"},{"type":"function","title":"Examples - Sidecar.GRPC.CodeGenerator.load_modules/1","doc":"```elixir\nopts = [output_path: \"/path/to/modules\"]\nmodules = load_modules(opts)\nIO.inspect(modules)\n\nThis example loads Elixir modules from the specified directory \"/path/to/modules\" and prints the content of each module.","ref":"Sidecar.GRPC.CodeGenerator.html#load_modules/1-examples"},{"type":"function","title":"Sidecar.GRPC.CodeGenerator.ls_r/1","doc":"","ref":"Sidecar.GRPC.CodeGenerator.html#ls_r/1"},{"type":"module","title":"Sidecar.GRPC.Dispatcher","doc":"Module for dispatching gRPC messages to Actors.\n\nThis module handles the dispatching of gRPC messages to Actors based on the provided parameters.\nIt logs relevant information and raises an error if the service descriptor is not found.","ref":"Sidecar.GRPC.Dispatcher.html"},{"type":"function","title":"Sidecar.GRPC.Dispatcher.dispatch/1","doc":"Dispatches a gRPC message to the specified actor.","ref":"Sidecar.GRPC.Dispatcher.html#dispatch/1"},{"type":"function","title":"Parameters: - Sidecar.GRPC.Dispatcher.dispatch/1","doc":"- `request` - A map containing the following parameters:\n  - `system: system_name` - The name of the actor system.\n  - `actor_name: actor_name` - The name of the actor.\n  - `action_name: action_name` - The name of action to call.\n  - `input: message` - The input message.\n  - `stream: stream` - The stream (optional).\n  - `descriptor: descriptor` - The service descriptor.","ref":"Sidecar.GRPC.Dispatcher.html#dispatch/1-parameters"},{"type":"function","title":"Example: - Sidecar.GRPC.Dispatcher.dispatch/1","doc":"```elixir\nrequest = %{\n  system: \"spawn-system\",\n  actor_name: \"GreeterActor\",\n  action_name: \"SayHello\",\n  input: %{data: \"some_data\"},\n  stream: %GRPC.Server.Stream{},\n  descriptor: %Google.Protobuf.FileDescriptorProto{\n    name: \"helloworld.proto\",\n    package: \"helloworld\"},\n    service: [\n      %Google.Protobuf.ServiceDescriptorProto{\n        name: \"GreeterActor\",\n        method: [\n          %Google.Protobuf.MethodDescriptorProto{\n            name: \"SayHello\",\n            input_type: \".helloworld.HelloRequest\",\n            output_type: \".helloworld.HelloReply\",\n          }\n        ]\n      }\n    ]\n  }\n}\n\nSidecar.GRPC.Dispatcher.dispatch(request)","ref":"Sidecar.GRPC.Dispatcher.html#dispatch/1-example"},{"type":"module","title":"Sidecar.GRPC.Generators.ActorInvoker","doc":"Module for generating an actor invoker helper.","ref":"Sidecar.GRPC.Generators.ActorInvoker.html"},{"type":"module","title":"Sidecar.GRPC.Generators.GRPCWithCustomOptions","doc":"Plugin to Generate gRPC code from protbuf service definitions, this plugin outputs any extension options\non service methods as a param to [`GRPC.Service.rpc/4`](https://github.com/drowzy/grpc/blob/grpc_transcoding/lib/grpc/service.ex#L56)","ref":"Sidecar.GRPC.Generators.GRPCWithCustomOptions.html"},{"type":"module","title":"Sidecar.GRPC.Generators.GeneratorAccumulator","doc":"Module for generating a gRPC proxy endpoint module.\n\nThis module implements the `ProtobufGenerate.Plugin` behaviour to generate a gRPC proxy endpoint\nmodule that includes specified gRPC services.","ref":"Sidecar.GRPC.Generators.GeneratorAccumulator.html"},{"type":"module","title":"Sidecar.GRPC.Generators.HandlerGenerator","doc":"Module for generating an actor dispatcher with transcoding capabilities for gRPC methods.\n\nThis module implements the `ProtobufGenerate.Plugin` behaviour to generate an actor dispatcher\nwith transcoding capabilities for each gRPC method defined in the Protobuf service.","ref":"Sidecar.GRPC.Generators.HandlerGenerator.html"},{"type":"module","title":"Sidecar.GRPC.Generators.HandlerTranscodingGenerator","doc":"Module for generating an actor dispatcher with transcoding capabilities for gRPC methods.\n\nThis module implements the `ProtobufGenerate.Plugin` behaviour to generate an actor dispatcher\nwith transcoding capabilities for each gRPC method defined in the Protobuf service.","ref":"Sidecar.GRPC.Generators.HandlerTranscodingGenerator.html"},{"type":"module","title":"Sidecar.GracefulShutdown","doc":"This module was copied and adapted from this project https://github.com/straw-hat-team/beam-monorepo\n\nCatches `SIGTERM` signal to gracefully stop the system.\nBy default, a `SIGTERM` signal triggers a `System.stop/0`. When running in a Kubernetes-managed cluster or an\ninfrastructure alike, the nodes will be joining and leaving the cluster when auto-scaling is enabled or when deploying\nnew version of the application.\nYou should let the system to gracefully stop in combination with readiness probe you can make sure that the system is\nready to stop without a relying on a `SIGKILL` signal.\n\nYou can read more about this at [Termination of Pods](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#pod-termination).\nWhen a `SIGTERM` is received, the handler enters \"connection draining mode\", during which `get_status/0` starts\nreturning `:draining` status, and then, after a delay, the handler calls `System.stop/1`, carefully halting the Erlang VM\nand starts returning `:stopping` status.","ref":"Sidecar.GracefulShutdown.html"},{"type":"function","title":"Sidecar.GracefulShutdown.child_spec/1","doc":"Returns a specification to start `Sidecar.GracefulShutdown` under a supervisor.\nSee the \"Child specification\" section in the Supervisor module for more detailed information.","ref":"Sidecar.GracefulShutdown.html#child_spec/1"},{"type":"function","title":"Sidecar.GracefulShutdown.get_status/0","doc":"Returns the status of the system.","ref":"Sidecar.GracefulShutdown.html#get_status/0"},{"type":"type","title":"Sidecar.GracefulShutdown.opts/0","doc":"Configuration options for the server.\n- `shutdown_delay_ms`: milliseconds before draining the VM after `SIGTERM`. milliseconds between start of connection draining\n    and ordered shut-down using `System.stop/0`.\n- `notify_pid`: process ID to notify when the server started draining.\n- `init_stop?`: whether to call `:System.stop/1` when a `SIGTERM` is received. Useful for testing since we don't want\n    to stop the VM when testing. **Be careful when using this option since it should always be `true` in production.**","ref":"Sidecar.GracefulShutdown.html#t:opts/0"},{"type":"function","title":"Sidecar.GracefulShutdown.running?/0","doc":"Returns true if the system is in the `:running` status.","ref":"Sidecar.GracefulShutdown.html#running?/0"},{"type":"type","title":"Sidecar.GracefulShutdown.status/0","doc":"The state of system.\n- `:draining` - the node is draining and will be shutdown after the delay.\n- `:stopping` - the node is shutting down.\n- `:running` - the node is accepting work.","ref":"Sidecar.GracefulShutdown.html#t:status/0"},{"type":"module","title":"Spawn","doc":"![Sepp](docs/images/sepp-elixir-254-400.png#gh-light-mode-only)\n![Sepp](docs/images/sepp-elixir-254-400.png#gh-dark-mode-only)\n\n**Actor Mesh Runtime**\n\n![ci](https://github.com/eigr/spawn/actions/workflows/ci.yaml/badge.svg)\n[![docs-ci](https://github.com/eigr/spawn/actions/workflows/pages/pages-build-deployment/badge.svg)](https://github.com/eigr/spawn/actions/workflows/pages/pages-build-deployment)\n![last commit](https://img.shields.io/github/last-commit/eigr/spawn?style=social)\n[![join discord](https://badgen.net/badge/discord/Join%20Eigr%20on%20Discord/discord?icon=discord&label&color=blue)](https://discord.gg/2PcshvfS93)\n[![twitter](https://badgen.net/badge/twitter/@eigr_io/blue?label&icon=twitter)](https://twitter.com/eigr_io)\n\n### **[Getting Started ](https://eigr.io/spawn/docs/getting_started.html)** • **[Website](https://eigr.io/spawn)** • **[Documentation](https://eigr.io/spawn/docs/)** • **[Blog](https://eigr.io/blog/)**","ref":"Spawn.html"},{"type":"module","title":"Overview - Spawn","doc":"Spawn is an actor-based service mesh that abstracts away infrastructure complexities while offering a powerful, polyglot API that accelerates business development. Built by contributors to [Cloudstate](https://github.com/cloudstateio/cloudstate), Spawn simplifies stateful application design for cloud or on-premises environments.\n\nWith support for multiple programming languages, Spawn empowers teams to work faster and smarter, using the best tools for the job. Whether you're scaling up or refining internal processes, Spawn’s architecture allows you to focus on what matters: delivering value to your business.\n\nExplore how Spawn can help you meet your business objectives efficiently. Check out our [documentation](docs/index.md) and [installation guide](docs/install.md) to [get started](docs/getting_started.md).","ref":"Spawn.html#module-overview"},{"type":"module","title":"Why Spawn? - Spawn","doc":"- **Simplified Infrastructure:** Spawn abstracts the complex backend architecture so developers can focus on writing business logic, not managing infrastructure.\n- **Stateful Computing Made Easy:** Spawn handles state management natively, allowing your applications to be both scalable and resilient across distributed systems.\n- **Polyglot Flexibility:** Build in the language of your choice, from Elixir to Java to TypeScript and others, all within the same ecosystem.\n- **Seamless Scalability:** Whether you’re deploying in the cloud or on-premises, Spawn grows with your business, ensuring high availability and performance.\n- **Designed for Business Needs:** Optimize productivity by streamlining your development process with a runtime that enables rapid time-to-market for critical features.","ref":"Spawn.html#module-why-spawn"},{"type":"module","title":"How Spawn Empowers Your Business - Spawn","doc":"By abstracting infrastructure, Spawn lets engineers focus on what truly drives growth—building features that matter. With automated state management and simplified configuration, Spawn accelerates development cycles and enhances team efficiency.\n\nFor technical leaders, Spawn provides the confidence to meet business goals more efficiently, enhancing competitiveness without compromising on scalability or technical robustness.","ref":"Spawn.html#module-how-spawn-empowers-your-business"},{"type":"module","title":"Latest Blogs - Spawn","doc":"* https://eigr.io/blog/spawn-the-actor-mesh/\n\n* https://eigr.io/blog/beyond-monoliths-and-microservices/\n\n* https://eigr.io/blog/distributed-elixir-made-easy-with-spawn/","ref":"Spawn.html#module-latest-blogs"},{"type":"module","title":"Engaging Talks - Spawn","doc":"Watch some insightful talks on Eigr Community and Spawn:\n\n- **Marcel Lanz on ACM SIGPLAN - Erlang 2021 - Lightning Talk**: https://www.youtube.com/watch?v=jVf0QqNb3qk _(English)_\n- **Marcel Lanz on Code Beam Europe 2022**: https://youtu.be/jgR7Oc_GXAg _(English)_\n- **Adriano Santos on Code Beam BR 2022**: https://www.youtube.com/watch?v=dXp0lyfmV_0&list=PLa5zLmv3pgCCiyWq8gltVAt2vTGuHz3eG&index=3 _(Portuguese)_\n- **Adriano Santos ElugSP 2023**: https://www.youtube.com/watch?v=MKTqiAtpK1E _(Portuguese)_\n- **Elias Arruda on Elixir CWB (Curitiba)**: https://www.youtube.com/live/yE_uWbPEWnI?si=5L3SORG3PERZpQ4V&t=463 _(Portuguese)_\n\n- **Adriano Santos NodeBR on Microsoft Reactor - API's Like a Boss**: https://www.youtube.com/live/ZXJJ3BdgVBk?si=Ai0kfBrVTl6V7toT&t=373 _(Portuguese)_","ref":"Spawn.html#module-engaging-talks"},{"type":"module","title":"Meet Sepp: Our Cyberpunk Mascot - Spawn","doc":"Say hello to Sepp, our cyberpunk mascot and proud [Ibex](https://alpshiking.swisshikingvacations.com/spotlight-on-the-ibex/). Sepp, hailing from the Swiss Alps, loves wandering through the Eiger mountains. Despite occasional Viking-like bluntness, he's a helpful companion who traces his lineage back to Viking times.\n\nThe name \"Sepp\" is indeed a German diminutive or nickname for the name Joseph. It's similar to how \"Joe\" is used as a nickname for Joseph in English. In German-speaking regions, it's common for Joseph to be affectionately referred to as \"Sepp.\"\n\nThis is our little tribute to one of the creators of the Erlang programming language, [Joe Armstrong](https://en.wikipedia.org/wiki/Joe_Armstrong_(programmer)).\n\n![Sepp Rules](docs/images/sepp-rules-254-400.png#gh-light-mode-only)\n![Sepp Rules](docs/images/sepp-rules-254-400.png#gh-dark-mode-only)\n\nWrite less code and be happy! 🌐🚀","ref":"Spawn.html#module-meet-sepp-our-cyberpunk-mascot"},{"type":"module","title":"Spawn.Actors.Healthcheck.HealthCheckActor.ActorDispatcher","doc":"","ref":"Spawn.Actors.Healthcheck.HealthCheckActor.ActorDispatcher.html"},{"type":"function","title":"Spawn.Actors.Healthcheck.HealthCheckActor.ActorDispatcher.liveness/2","doc":"","ref":"Spawn.Actors.Healthcheck.HealthCheckActor.ActorDispatcher.html#liveness/2"},{"type":"function","title":"Spawn.Actors.Healthcheck.HealthCheckActor.ActorDispatcher.readiness/2","doc":"","ref":"Spawn.Actors.Healthcheck.HealthCheckActor.ActorDispatcher.html#readiness/2"},{"type":"function","title":"Spawn.Actors.Healthcheck.HealthCheckActor.ActorDispatcher.service_name/1","doc":"","ref":"Spawn.Actors.Healthcheck.HealthCheckActor.ActorDispatcher.html#service_name/1"},{"type":"module","title":"Spawn.Cache.LookupCache","doc":"","ref":"Spawn.Cache.LookupCache.html"},{"type":"function","title":"Spawn.Cache.LookupCache.__primary__/0","doc":"A convenience function for getting the primary storage cache.","ref":"Spawn.Cache.LookupCache.html#__primary__/0"},{"type":"function","title":"Spawn.Cache.LookupCache.get_node/1","doc":"A convenience function to get the node of the given `key`.","ref":"Spawn.Cache.LookupCache.html#get_node/1"},{"type":"function","title":"Spawn.Cache.LookupCache.join_cluster/0","doc":"A convenience function for joining the cache to the cluster.","ref":"Spawn.Cache.LookupCache.html#join_cluster/0"},{"type":"function","title":"Spawn.Cache.LookupCache.leave_cluster/0","doc":"A convenience function for removing the cache from the cluster.","ref":"Spawn.Cache.LookupCache.html#leave_cluster/0"},{"type":"function","title":"Spawn.Cache.LookupCache.nodes/0","doc":"A convenience function for getting the cluster nodes.","ref":"Spawn.Cache.LookupCache.html#nodes/0"},{"type":"module","title":"Spawn.Cache.LookupCache.Primary","doc":"This is the cache for the primary storage.","ref":"Spawn.Cache.LookupCache.Primary.html"},{"type":"function","title":"Spawn.Cache.LookupCache.Primary.generations/0","doc":"A convenience function for retrieving the current generations.","ref":"Spawn.Cache.LookupCache.Primary.html#generations/0"},{"type":"function","title":"Spawn.Cache.LookupCache.Primary.new_generation/1","doc":"A convenience function for creating new generations.","ref":"Spawn.Cache.LookupCache.Primary.html#new_generation/1"},{"type":"function","title":"Spawn.Cache.LookupCache.Primary.newer_generation/0","doc":"A convenience function for retrieving the newer generation.","ref":"Spawn.Cache.LookupCache.Primary.html#newer_generation/0"},{"type":"function","title":"Spawn.Cache.LookupCache.Primary.reset_generation_timer/0","doc":"A convenience function for reset the GC timer.","ref":"Spawn.Cache.LookupCache.Primary.html#reset_generation_timer/0"},{"type":"module","title":"Spawn.Cluster.Node.Client","doc":"","ref":"Spawn.Cluster.Node.Client.html"},{"type":"module","title":"Spawn.Cluster.Node.Registry","doc":"Defines a distributed registry for all process","ref":"Spawn.Cluster.Node.Registry.html"},{"type":"function","title":"Spawn.Cluster.Node.Registry.child_spec/0","doc":"","ref":"Spawn.Cluster.Node.Registry.html#child_spec/0"},{"type":"function","title":"Spawn.Cluster.Node.Registry.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\nSee `Supervisor`.","ref":"Spawn.Cluster.Node.Registry.html#child_spec/1"},{"type":"function","title":"Spawn.Cluster.Node.Registry.is_alive?/2","doc":"Check if Process is alive.","ref":"Spawn.Cluster.Node.Registry.html#is_alive?/2"},{"type":"function","title":"Spawn.Cluster.Node.Registry.list_actor_pids/1","doc":"List all alive PIDs from given registry module.","ref":"Spawn.Cluster.Node.Registry.html#list_actor_pids/1"},{"type":"function","title":"Spawn.Cluster.Node.Registry.lookup/2","doc":"Get Process if this is alive.","ref":"Spawn.Cluster.Node.Registry.html#lookup/2"},{"type":"function","title":"Spawn.Cluster.Node.Registry.update_entry_value/4","doc":"Update value meta inside registry","ref":"Spawn.Cluster.Node.Registry.html#update_entry_value/4"},{"type":"module","title":"Spawn.Cluster.Node.Server","doc":"Node subscriber","ref":"Spawn.Cluster.Node.Server.html"},{"type":"function","title":"Spawn.Cluster.Node.Server.error/2","doc":"","ref":"Spawn.Cluster.Node.Server.html#error/2"},{"type":"function","title":"Spawn.Cluster.Node.Server.request/1","doc":"","ref":"Spawn.Cluster.Node.Server.html#request/1"},{"type":"protocol","title":"Spawn.Cluster.Provisioner.Executor","doc":"","ref":"Spawn.Cluster.Provisioner.Executor.html"},{"type":"function","title":"Spawn.Cluster.Provisioner.Executor.execute/2","doc":"Executes a task","ref":"Spawn.Cluster.Provisioner.Executor.html#execute/2"},{"type":"type","title":"Spawn.Cluster.Provisioner.Executor.t/0","doc":"All the types that implement this protocol.","ref":"Spawn.Cluster.Provisioner.Executor.html#t:t/0"},{"type":"module","title":"Spawn.Cluster.Provisioner.Scheduler","doc":"The `Spawn.Cluster.Provisioner.Scheduler` module is responsible for scheduling tasks and invoking functions in a distributed actor system.\nIt handles creating worker pools and executing functions with the given task configuration.\n\nThis module also contains an implementation of the `Executor` protocol for the `SpawnTask` struct,\ndefining the execution behavior for tasks in the context of provisioning actors in the cluster.","ref":"Spawn.Cluster.Provisioner.Scheduler.html"},{"type":"function","title":"Spawn.Cluster.Provisioner.Scheduler.schedule_and_invoke/2","doc":"Schedules and invokes a task for actor provisioning in another k8s POD.\n\nThis function wraps the scheduling logic by leveraging the `Executor` protocol to execute the provided\nfunction (`func`). The function is called with the `invocation`, `opts`, and `state` details encapsulated in a `SpawnTask` struct.","ref":"Spawn.Cluster.Provisioner.Scheduler.html#schedule_and_invoke/2"},{"type":"function","title":"Parameters - Spawn.Cluster.Provisioner.Scheduler.schedule_and_invoke/2","doc":"- `actor_name`: The actor name reference used to create the worker pool for the task execution.\n  - `invocation`: The details of the invocation, typically containing metadata about the actor's execution.\n  - `opts`: Options passed along with the task, which may modify how the invocation is performed.\n  - `state`: The current state of the process, to be passed to the function being invoked.\n  - `func`: A function that will be called with the `{invocation, opts}` tuple and the current `state`.","ref":"Spawn.Cluster.Provisioner.Scheduler.html#schedule_and_invoke/2-parameters"},{"type":"function","title":"Example - Spawn.Cluster.Provisioner.Scheduler.schedule_and_invoke/2","doc":"```elixir\ntask = %SpawnTask{\n  actor: actor,\n  invocation: invocation,\n  opts: opts,\n  state: state\n}\n\nSpawn.Cluster.Provisioner.Scheduler.schedule_and_invoke(task, &some_function/2)","ref":"Spawn.Cluster.Provisioner.Scheduler.html#schedule_and_invoke/2-example"},{"type":"module","title":"Spawn.Cluster.Provisioner.SpawnTask","doc":"","ref":"Spawn.Cluster.Provisioner.SpawnTask.html"},{"type":"behaviour","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour","doc":"Behavior for managing the state of clustered processes a.k.a lookups.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html"},{"type":"callback","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.clean/2","doc":"Cleanup action.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:clean/2"},{"type":"type","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.data/0","doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:data/0"},{"type":"callback","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.get_by_id/2","doc":"Fetch the ActorHost process reference by id.\nIn case `id` is the hash of the ActorId but here the struct ActorId is passed as a parameter.\nAn implementations must handle this.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:get_by_id/2"},{"type":"callback","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_after_init/1","doc":"Any procedure to be executed after the StateHandoffManager is initialized.\nExecuted during callback call to handle_continue.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_after_init/1"},{"type":"callback","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_init/1","doc":"Any initialization code required by implementations of this behavior.\nMust return the state to be added in the StateHandoffManager.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_init/1"},{"type":"callback","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_nodedown_event/3","doc":"If necessary any procedure to be executed during a nodedown event","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_nodedown_event/3"},{"type":"callback","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_nodeup_event/3","doc":"If necessary any procedure to be executed during a nodeup event","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_nodeup_event/3"},{"type":"callback","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_terminate/2","doc":"Perform any necessary cleanups during StateHandoffManager termination.\nGenerally excluding references to all processes owned by the terminating node.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_terminate/2"},{"type":"callback","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_timer/2","doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_timer/2"},{"type":"type","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.host/0","doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:host/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.hosts/0","doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:hosts/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.id/0","doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:id/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.new_data/0","doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:new_data/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.node_type/0","doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:node_type/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.opts/0","doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:opts/0"},{"type":"callback","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.set/4","doc":"Adds a reference to an ActorHost process.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:set/4"},{"type":"type","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.timer/0","doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:timer/0"},{"type":"module","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController","doc":"This handles state handoff in a cluster.\n\nIt uses the DeltaCrdt library to handle a distributed state, which is an eventually consistent replicated data type.\nThe module starts a GenServer that monitors nodes in the cluster, and when a new node comes up it sends a \"set_neighbours\"\nmessage to that node's GenServer process with its own DeltaCrdt process ID. This is done to ensure that changes in either node's\nstate are reflected across both.\n\nThe module also handles other messages like \"handoff\" and \"get\" to put and retrieve data from the DeltaCrdt state, respectively.","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html"},{"type":"function","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.clean/2","doc":"Cluster HostActor cleanup","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#clean/2"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.data/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:data/0"},{"type":"function","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.get_crdt_pid/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#get_crdt_pid/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.host/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:host/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.hosts/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:hosts/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.id/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:id/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.new_data/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:new_data/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.node_type/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:node_type/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.opts/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:opts/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.timer/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:timer/0"},{"type":"module","title":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController","doc":"This handles state handoff in a cluster.\n\nIt uses the Nats jetstream library to handle a distributed state, which is an eventually consistent replicated data type.","ref":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.html"},{"type":"function","title":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.clean/2","doc":"Cluster HostActor cleanup","ref":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.html#clean/2"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.data/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.html#t:data/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.host/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.html#t:host/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.hosts/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.html#t:hosts/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.id/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.html#t:id/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.new_data/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.html#t:new_data/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.node_type/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.html#t:node_type/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.opts/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.html#t:opts/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.timer/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.NatsKvController.html#t:timer/0"},{"type":"module","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController","doc":"`StateHandoffPersistentController` is a StateHandoff Controller basead on `Statestore` mechanism.","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.data/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:data/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.host/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:host/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.hosts/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:hosts/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.id/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:id/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.new_data/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:new_data/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.node_type/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:node_type/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.opts/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:opts/0"},{"type":"type","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.timer/0","doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:timer/0"},{"type":"module","title":"Spawn.Cluster.StateHandoff.InvocationSchedulerState","doc":"This handles invocation scheduler stream\n\nIt uses the DeltaCrdt library to handle a distributed state, which is an eventually consistent replicated data type.\nThe module starts a GenServer that monitors nodes in the cluster, and when a new node comes up it sends a \"set_neighbours\"\nmessage to that node's GenServer process with its own DeltaCrdt process ID. This is done to ensure that changes in either node's\nstate are reflected across both.","ref":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.html"},{"type":"function","title":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.all/0","doc":"","ref":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.html#all/0"},{"type":"function","title":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.html#child_spec/1"},{"type":"function","title":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.get/1","doc":"","ref":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.html#get/1"},{"type":"function","title":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.get_crdt_pid/0","doc":"","ref":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.html#get_crdt_pid/0"},{"type":"function","title":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.put/3","doc":"","ref":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.html#put/3"},{"type":"function","title":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.put_many/1","doc":"","ref":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.html#put_many/1"},{"type":"function","title":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.remove/1","doc":"","ref":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.html#remove/1"},{"type":"function","title":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.start_link/1","doc":"","ref":"Spawn.Cluster.StateHandoff.InvocationSchedulerState.html#start_link/1"},{"type":"module","title":"Spawn.Cluster.StateHandoff.Manager","doc":"This handles state handoff in a cluster.\n\nThis module monitors node up and down events as well as node terminate events and triggers `Spawn.Cluster.StateHandoff.ControllerBehaviour` implementations to handle these events.","ref":"Spawn.Cluster.StateHandoff.Manager.html"},{"type":"function","title":"Spawn.Cluster.StateHandoff.Manager.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Spawn.Cluster.StateHandoff.Manager.html#child_spec/1"},{"type":"function","title":"Spawn.Cluster.StateHandoff.Manager.child_spec/2","doc":"","ref":"Spawn.Cluster.StateHandoff.Manager.html#child_spec/2"},{"type":"function","title":"Spawn.Cluster.StateHandoff.Manager.clean/1","doc":"Cluster HostActor cleanup","ref":"Spawn.Cluster.StateHandoff.Manager.html#clean/1"},{"type":"function","title":"Spawn.Cluster.StateHandoff.Manager.get/1","doc":"Pickup the stored entity data for a actor","ref":"Spawn.Cluster.StateHandoff.Manager.html#get/1"},{"type":"function","title":"Spawn.Cluster.StateHandoff.Manager.set/2","doc":"Store a actor and entity in the lookup store","ref":"Spawn.Cluster.StateHandoff.Manager.html#set/2"},{"type":"function","title":"Spawn.Cluster.StateHandoff.Manager.start_link/1","doc":"","ref":"Spawn.Cluster.StateHandoff.Manager.html#start_link/1"},{"type":"module","title":"Spawn.Cluster.StateHandoff.Manager.State","doc":"","ref":"Spawn.Cluster.StateHandoff.Manager.State.html"},{"type":"module","title":"Spawn.Utils.AnySerializer","doc":"`AnySerializer` is responsible for serializing the protobuf type Any to Elixir\nstructures and vice versa.","ref":"Spawn.Utils.AnySerializer.html"},{"type":"function","title":"Spawn.Utils.AnySerializer.any_pack!/1","doc":"","ref":"Spawn.Utils.AnySerializer.html#any_pack!/1"},{"type":"function","title":"Spawn.Utils.AnySerializer.any_unpack!/2","doc":"","ref":"Spawn.Utils.AnySerializer.html#any_unpack!/2"},{"type":"function","title":"Spawn.Utils.AnySerializer.json_any_pack!/1","doc":"","ref":"Spawn.Utils.AnySerializer.html#json_any_pack!/1"},{"type":"function","title":"Spawn.Utils.AnySerializer.normalize_no_package/1","doc":"","ref":"Spawn.Utils.AnySerializer.html#normalize_no_package/1"},{"type":"function","title":"Spawn.Utils.AnySerializer.normalize_package_name/1","doc":"","ref":"Spawn.Utils.AnySerializer.html#normalize_package_name/1"},{"type":"function","title":"Spawn.Utils.AnySerializer.pack_all_to_any/2","doc":"","ref":"Spawn.Utils.AnySerializer.html#pack_all_to_any/2"},{"type":"function","title":"Spawn.Utils.AnySerializer.unpack_any_bin/1","doc":"","ref":"Spawn.Utils.AnySerializer.html#unpack_any_bin/1"},{"type":"function","title":"Spawn.Utils.AnySerializer.unpack_unknown/1","doc":"","ref":"Spawn.Utils.AnySerializer.html#unpack_unknown/1"},{"type":"exception","title":"Actors.Exceptions.NetworkPartitionException","doc":"Error raised when the Actor already activated on another node.","ref":"Actors.Exceptions.NetworkPartitionException.html"},{"type":"function","title":"Actors.Exceptions.NetworkPartitionException.message/1","doc":"","ref":"Actors.Exceptions.NetworkPartitionException.html#message/1"},{"type":"exception","title":"Actors.Exceptions.NotAuthorizedException","doc":"Error raised when the Actor understands the request but refuses to authorize it.\n\nThis error should result in a http 403 status code.\nsee: https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/403","ref":"Actors.Exceptions.NotAuthorizedException.html"},{"type":"function","title":"Actors.Exceptions.NotAuthorizedException.message/1","doc":"","ref":"Actors.Exceptions.NotAuthorizedException.html#message/1"},{"type":"extras","title":"Spawn: Drive Your Business with Stateful Computing","doc":"# Spawn: Drive Your Business with Stateful Computing\n\n<!-- MDOC !-->\n\n![Sepp](docs/images/sepp-elixir-254-400.png#gh-light-mode-only)\n![Sepp](docs/images/sepp-elixir-254-400.png#gh-dark-mode-only)\n\n**Actor Mesh Runtime**\n\n![ci](https://github.com/eigr/spawn/actions/workflows/ci.yaml/badge.svg)\n[![docs-ci](https://github.com/eigr/spawn/actions/workflows/pages/pages-build-deployment/badge.svg)](https://github.com/eigr/spawn/actions/workflows/pages/pages-build-deployment)\n![last commit](https://img.shields.io/github/last-commit/eigr/spawn?style=social)\n[![join discord](https://badgen.net/badge/discord/Join%20Eigr%20on%20Discord/discord?icon=discord&label&color=blue)](https://discord.gg/2PcshvfS93)\n[![twitter](https://badgen.net/badge/twitter/@eigr_io/blue?label&icon=twitter)](https://twitter.com/eigr_io)\n\n### **[Getting Started ](https://eigr.io/spawn/docs/getting_started.html)** • **[Website](https://eigr.io/spawn)** • **[Documentation](https://eigr.io/spawn/docs/)** • **[Blog](https://eigr.io/blog/)**","ref":"readme.html"},{"type":"extras","title":"Overview - Spawn: Drive Your Business with Stateful Computing","doc":"Spawn is an actor-based service mesh that abstracts away infrastructure complexities while offering a powerful, polyglot API that accelerates business development. Built by contributors to [Cloudstate](https://github.com/cloudstateio/cloudstate), Spawn simplifies stateful application design for cloud or on-premises environments.\n\nWith support for multiple programming languages, Spawn empowers teams to work faster and smarter, using the best tools for the job. Whether you're scaling up or refining internal processes, Spawn’s architecture allows you to focus on what matters: delivering value to your business.\n\nExplore how Spawn can help you meet your business objectives efficiently. Check out our [documentation](docs/index.md) and [installation guide](docs/install.md) to [get started](docs/getting_started.md).","ref":"readme.html#overview"},{"type":"extras","title":"Why Spawn? - Spawn: Drive Your Business with Stateful Computing","doc":"- **Simplified Infrastructure:** Spawn abstracts the complex backend architecture so developers can focus on writing business logic, not managing infrastructure.\n- **Stateful Computing Made Easy:** Spawn handles state management natively, allowing your applications to be both scalable and resilient across distributed systems.\n- **Polyglot Flexibility:** Build in the language of your choice, from Elixir to Java to TypeScript and others, all within the same ecosystem.\n- **Seamless Scalability:** Whether you’re deploying in the cloud or on-premises, Spawn grows with your business, ensuring high availability and performance.\n- **Designed for Business Needs:** Optimize productivity by streamlining your development process with a runtime that enables rapid time-to-market for critical features.","ref":"readme.html#why-spawn"},{"type":"extras","title":"How Spawn Empowers Your Business - Spawn: Drive Your Business with Stateful Computing","doc":"By abstracting infrastructure, Spawn lets engineers focus on what truly drives growth—building features that matter. With automated state management and simplified configuration, Spawn accelerates development cycles and enhances team efficiency.\n\nFor technical leaders, Spawn provides the confidence to meet business goals more efficiently, enhancing competitiveness without compromising on scalability or technical robustness.","ref":"readme.html#how-spawn-empowers-your-business"},{"type":"extras","title":"Latest Blogs - Spawn: Drive Your Business with Stateful Computing","doc":"* https://eigr.io/blog/spawn-the-actor-mesh/\n\n* https://eigr.io/blog/beyond-monoliths-and-microservices/\n\n* https://eigr.io/blog/distributed-elixir-made-easy-with-spawn/","ref":"readme.html#latest-blogs"},{"type":"extras","title":"Engaging Talks - Spawn: Drive Your Business with Stateful Computing","doc":"Watch some insightful talks on Eigr Community and Spawn:\n\n- **Marcel Lanz on ACM SIGPLAN - Erlang 2021 - Lightning Talk**: https://www.youtube.com/watch?v=jVf0QqNb3qk _(English)_\n- **Marcel Lanz on Code Beam Europe 2022**: https://youtu.be/jgR7Oc_GXAg _(English)_\n- **Adriano Santos on Code Beam BR 2022**: https://www.youtube.com/watch?v=dXp0lyfmV_0&list=PLa5zLmv3pgCCiyWq8gltVAt2vTGuHz3eG&index=3 _(Portuguese)_\n- **Adriano Santos ElugSP 2023**: https://www.youtube.com/watch?v=MKTqiAtpK1E _(Portuguese)_\n- **Elias Arruda on Elixir CWB (Curitiba)**: https://www.youtube.com/live/yE_uWbPEWnI?si=5L3SORG3PERZpQ4V&t=463 _(Portuguese)_\n\n- **Adriano Santos NodeBR on Microsoft Reactor - API's Like a Boss**: https://www.youtube.com/live/ZXJJ3BdgVBk?si=Ai0kfBrVTl6V7toT&t=373 _(Portuguese)_","ref":"readme.html#engaging-talks"},{"type":"extras","title":"Meet Sepp: Our Cyberpunk Mascot - Spawn: Drive Your Business with Stateful Computing","doc":"Say hello to Sepp, our cyberpunk mascot and proud [Ibex](https://alpshiking.swisshikingvacations.com/spotlight-on-the-ibex/). Sepp, hailing from the Swiss Alps, loves wandering through the Eiger mountains. Despite occasional Viking-like bluntness, he's a helpful companion who traces his lineage back to Viking times.\n\nThe name \"Sepp\" is indeed a German diminutive or nickname for the name Joseph. It's similar to how \"Joe\" is used as a nickname for Joseph in English. In German-speaking regions, it's common for Joseph to be affectionately referred to as \"Sepp.\"\n\nThis is our little tribute to one of the creators of the Erlang programming language, [Joe Armstrong](https://en.wikipedia.org/wiki/Joe_Armstrong_(programmer)).\n\n![Sepp Rules](docs/images/sepp-rules-254-400.png#gh-light-mode-only)\n![Sepp Rules](docs/images/sepp-rules-254-400.png#gh-dark-mode-only)\n\nWrite less code and be happy! 🌐🚀","ref":"readme.html#meet-sepp-our-cyberpunk-mascot"}],"proglang":"elixir","producer":{"name":"ex_doc","version":"0.37.2"},"content_type":"text/markdown"}